<?php

/*

J.A.G. (Just Another Guestbook) v1.14

Copyright (C) 2003 crisp - freesoftware@xs4all.nl

See full notice in guestbook.php

*/


// Settings
$adminpwd = array();
$stylesheet = 'default.css';
$default_language = 'en';
include ('./inc/config.php');
include ('./inc/general.php');

if (empty($adminpwd)) redirect('guestbook.php');

// Language
$lang = $default_language;
if (isset($_SESSION['language'])) $lang = $_SESSION['language'];
@include ('./lang/language_'.$lang.'.php');

// init
$user = '';
$pw = '';
$action = '';
$error = '';
$returnpath = 'guestbook.php';

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

  // Get POST vars
  if (isset($_POST['user'])) $user = $_POST['user'];
  if (isset($_POST['pw'])) $pw = $_POST['pw'];
  if (isset($_POST['action'])) $action = $_POST['action'];
  if (isset($_POST['returnpath'])) $returnpath = $_POST['returnpath'];

  if (get_magic_quotes_gpc()) {

    $user = stripslashes($user);
    $pw = stripslashes($pw);

  }

  if ($action == 'login' && isset ($_SESSION['random'])) {

    if (isset($adminpwd[$user])) {

      $rand = $_SESSION['random'];
      $pwd = $adminpwd[$user];
      $check = md5($pwd.$rand);

      if ($pw == $check) {

        $_SESSION['loggedin'] = isset($guestbook_id)? $guestbook_id:'JAG';
        $_SESSION['curuser'] = $user;

        redirect($returnpath);

      } else {

        $error .= '<b>'.$LANG['WrongPwd'].'</b><br />'.CR;
        sleep(2);

      }

    } else {

      $error .= '<b>'.$LANG['WrongUser'].'</b><br />'.CR;
      sleep(2);

    }

  }

} else {

  // Get GET vars
  if (isset($_GET['action'])) $action = $_GET['action'];
  if (isset($_GET['returnpath'])) $returnpath = $_GET['returnpath'];

  if ($action == 'logout') {

    $_SESSION = array();
    session_destroy();
    if ($lang != $default_language) $returnpath = 'guestbook.php?lang='.$lang;

    redirect($returnpath);

  }

}

$passwordChars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';

$rand = '';
mt_srand ((double) microtime() * 1000000); 

for ($i = 0; $i < 32; $i++) {

  // pick random number
  $random = mt_rand(1, strlen($passwordChars));

  $rand .= substr($passwordChars, $random-1, 1);

}

$_SESSION['random'] = $rand;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- J.A.G. (Just Another Guestbook) v<?php echo $version; ?> - GNU Copyright (c) 2003 by crisp / freesoftware[at]xs4all.nl -->
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Pragma" content="no-cache">
<meta name="robots" content="noindex,nofollow">
<title><?php echo $guestbook_name.' - '.$LANG['login']; ?></title>
<link rel="stylesheet" href="style/<?php echo $stylesheet; ?>" type="text/css">
<script type="text/javascript" src="js/md5.js"></script>
<script type="text/javascript">

var rand = '<?php echo $rand; ?>';

function hashpw() {

  var user = document.forms['login'].elements['user'].value;
  var pw = document.forms['login'].elements['pw'].value;

  if (!user) {
    alert('<?php echo $LANG['NoUser']; ?>');
    document.forms['login'].elements['user'].focus()
    return false;
  }
  if (!pw) {
    alert('<?php echo $LANG['NoPwd']; ?>');
    document.forms['login'].elements['pw'].focus()
    return false;
  }

  document.forms['snd_login'].elements['user'].value = user;
  document.forms['snd_login'].elements['pw'].value = calcMD5(pw + rand);
  document.forms['snd_login'].submit();
  return false;

}

</script>
</head>
<body onload="document.forms['login'].elements['user'].focus()">
<?php

echo '<table>'.CR.
     '  <tr>'.CR.
     '    <td class="title"><a class="title" href="guestbook.php">'.$LANG['Back'].'</a></td>'.CR.
     '  </tr>'.CR.
     '</table><br />'.CR;

if ($error) echo $error.'<br />'.CR;

?>
<table>
  <tr>
    <td class="content"><div class="noalfa">
      <form name="login" action="admin.php" method="post" onsubmit="return hashpw()">
        <table class="noborder">
          <tr>
            <td width="120"><br /></td>
            <td><br /></td>
          </tr>
          <tr>
            <td valign="top"><?php echo $LANG['username']; ?>:</td>
            <td><input type="text" name="user" value="<?php echo htmlentities($user); ?>" size="30" maxlength="30" style="width: 224px; height:22px"></td>
          </tr>
          <tr>
            <td valign="top"><?php echo $LANG['password']; ?>:</td>
            <td><input type="password" name="pw" value="" size="30" maxlength="32" style="width: 224px; height:22px"></td>
          </tr>
          <tr>
            <td></td>
            <td><br /><input type="submit" value="<?php echo $ACTION['login']; ?>"></td>
          </tr>
        </table><br />
      </form>
      <form name="snd_login" action="admin.php" method="post">
        <input type="hidden" name="user" value="" />
        <input type="hidden" name="pw" value="" />
        <input type="hidden" name="action" value="login" />
        <input type="hidden" name="returnpath" value="<?php echo $returnpath ?>" />
      </form>
    </div></td>
  </tr>
</table><br />
<?php include ('./inc/copyright.php'); ?>
</body>
</html>