<?php

/*

            J.A.G. (Just Another Guestbook) v1.14

Copyright (C) 2003 crisp - freesoftware@xs4all.nl

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Further to the terms mentioned you should leave the copyright footer and
copyright notice in the HTML headers intact, stating me as the original author.

*/


//timer
$start_time = microtime();

// Settings
$version = 0;
$curversion = 1.14;
$error = '';
$readonly = 0;
$lockdown = 0;
$lock_msg = '';
$stylesheet = 'default.css';
$default_language = 'en';
@include ('./inc/config.php');
include ('./inc/general.php');

// Get GET vars
$start = 0;
$lang = $default_language;
if (isset($_GET['start'])) $start = $_GET['start'];
if (isset($_GET['lang'])) {
  if (isset($_SESSION['language'])) unset($_SESSION['language']);
  if (isset($avail_languages[$_GET['lang']]) && $_GET['lang'] != $default_language) {
    $lang = $_GET['lang'];
    $_SESSION['language'] = $lang;
  }
} else if (isset($_SESSION['language'])) {
  $lang = $_SESSION['language'];
}

// Include language template
if (!@include ('./lang/language_'.$lang.'.php')) {
  if (isset($_SESSION['language'])) unset($_SESSION['language']);
  $wronglang = $lang;
  $lang = 'en';
  include ('./lang/language_'.$lang.'.php');
  $error .= '<b>'.str_replace('$lang', $wronglang, $LANG['NoLanguage']).'<b><br />'.CR;
}

// Version check
if ($version < $curversion || !isset($guestbook_id)) redirect('setup.php');

// check for admin
$admin = 0;
if (isset($_SESSION['loggedin']) && $_SESSION['loggedin'] == $guestbook_id) $admin = 1;

// mySQL Connect
if (!$lockdown || $admin) {
  if (!$conn_id = @mysql_connect($host, $id, $pw)) $error .= '<b>'.$LANG['NoConn'].'</b><br />'.CR;
  else if (!@mysql_select_db($database, $conn_id)) $error .= '<b>'.str_replace('$database', $database, $LANG['NoDB']).'</b><br />'.CR;
  else {
    if (!$admin) {
      include ('./inc/chkban.php');
      $checkip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
      if (checkban($checkip, $conn_id)) {
        $lockdown = 1;
        $error .= '<b>'.$LANG['Banned'].'</b><br />'.CR;
      }
    }
    if (!$lockdown && !$result = @mysql_query('select count(nr) from '.$table, $conn_id)) $error .= '<b>'.str_replace('$table', $table, $LANG['NoTable']).'</b><br />'.CR;
  }
} else {
  $error .= '<b>'.$lock_msg.'</b><br />'.CR;
}

if (!$error) {

  // Message parser and dateformat modules
  include('./inc/parser.php');
  include('./inc/formatdate.php');

}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- J.A.G. (Just Another Guestbook) v<?php echo $version; ?> - GNU Copyright (c) 2003 by crisp / freesoftware[at]xs4all.nl -->
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Pragma" content="no-cache">
<meta name="robots" content="index,nofollow">
<meta name="description" content="J.A.G. (Just Another Guestbook), visit http://www.xs4all.nl/~crisp/jag/index.html for your free copy!">
<title><?php echo $guestbook_name.' - '.$LANG['guestbook']; ?></title>
<link rel="stylesheet" href="style/<?php echo $stylesheet; ?>" type="text/css">
</head>
<body>
<?php

echo '<table>'.CR.
     '  <tr>'.CR.
     '    <td class="title">';
if (!$error && !$readonly || ($admin && ($readonly || $lockdown))) {
  echo '<a class="title" href="message.php?page=new">'.$LANG['NewMessage'].'</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a class="title" href="lang/faq_'.$lang.'.php">'.$LANG['FAQ'].'</a>';
  if (count($avail_languages) > 1) {
    echo '&nbsp;&nbsp;|';
    $languages = array_keys($avail_languages);
    for ($i = 0, $tot = count($languages); $i < $tot; $i++) {
      if ($languages[$i] != $lang) echo '&nbsp;&nbsp;<a href="guestbook.php?start='.$start.'&lang='.$languages[$i].'"><img class="button" src="lang/flag_'.$languages[$i].'.gif" width="14" height="14" border="0" alt="'.$avail_languages[$languages[$i]].'" title="'.$avail_languages[$languages[$i]].'" /></a>';
    }
  }
}
echo '</td>'.CR.
     '    <td class="title" width="370" align="right">';
if ($admin) {
  echo '<a class="title" href="tools.php">'.$LANG['Tools'].'</a>&nbsp;&nbsp;|&nbsp;&nbsp;'.
       '<a class="title" href="banlist.php">'.$LANG['Banlist'].'</a>&nbsp;&nbsp;|&nbsp;&nbsp;'.
       '<a class="title" href="setup.php">'.$LANG['Settings'].'</a>&nbsp;&nbsp;|&nbsp;&nbsp;'.
       '<a class="title" href="admin.php?action=logout">'.$LANG['Logout'].'</a>';
} else {
  echo '<a class="title" href="admin.php">'.$LANG['Login'].'</a>';
}
echo '    </td>'.CR.
     '  </tr>'.CR.
     '</table><br />'.CR; 

if ($error) {

  echo $error;
  if (!$lockdown) echo '<br /><b>'.$LANG['Correct'].'</b>'.CR;

} else {

  // Check number of pages

  $row = mysql_fetch_row($result);
  $number = $row[0];
  $navigation = '';

  if ($number > $messages_per_page) {

    $navigation .= $LANG['Page'].':';
    $pages = intval($number / $messages_per_page);
    if ($number % $messages_per_page) $pages++;
    $curpage = intval($start / $messages_per_page + 1);

    $pl = intval($navlength / 2);
    $length = $navlength - 1;
    $pr = $length - $pl;
    $s = 1;
    if ($start > $pl * $messages_per_page && $pages > $length) $s = $curpage - $pl;
    if ($start + $pr * $messages_per_page >= $number && $pages > $length) $s = $pages - $length;
    $e = $s + $length;
    if ($e > $pages) $e = $pages;

    for ($i = $s; $i <= $e; $i++) {

      $fwd = ($i - 1) * $messages_per_page;
      $fwdnumber = ($fwd / $messages_per_page + 1);

      if ($i == $curpage){
        $navigation .= '&nbsp;&nbsp;'.$fwdnumber;
      } else {
        $navigation .= '&nbsp;&nbsp;<a class="nav" href="guestbook.php?start='.$fwd.'">'.$fwdnumber.'</a>';
      }

    }

    if ($pages > $e) $navigation .= '&nbsp;&nbsp;+';

    echo '<table class="noborder">'.CR.
         '  <tr>'.CR.
         '    <td class="nav">'.$navigation.'</td>'.CR;

    echo '    <td class="nav" align="right">'.$LANG['QuickSel'].':'.CR.
         '      <select onChange="window.location.href = this.value" style="font-size: 10px; height: 18px">';

    for ($i = 1; $i <= $pages; $i++) {

      $fwd = ($i - 1) * $messages_per_page;
      echo '        <option value="guestbook.php?start='.$fwd.'"';
      if ($i == $curpage) echo ' selected';
      echo '>'.$LANG['Page'].' '.$i.'&nbsp;&nbsp;</option>'.CR;

    }

    echo '      </select>'.CR.
         '    </td>'.CR;

    echo '  </tr>'.CR.
         '</table>'.CR;

  }

  // Retrieve array of messages user is allowed to edit
  $allowedit = array();
  if ($allow_edit && isset($_SESSION['editid'])) $allowedit = $_SESSION['editid'];

  // Show all messages
  $query = 'select * from '.$table.' order by datum desc limit '.$start.', '.$messages_per_page;
  $result = mysql_query($query, $conn_id);

  if (mysql_num_rows($result)) {

    $anchor = 0;
    while($row=mysql_fetch_assoc($result)) {  

      $nr = $row['nr'];
      $name = $row['name'];
      $open = $row['open'];
      $ip = $row['ip'];
      $email = $row['email'];
      $location = $row['location'];
      $homepage = $row['homepage'];
      $content = $row['content'];
      $comment = $row['comment'];
      $datum = formatdate($row['datum'], $datetimeformat, $timeshift);
      $anchor++;

      // parse field contents
      $name = parsecontent(0, 0, 0, 0, $name);
      $email = parsecontent(0, 0, 0, 0, $email);
      $email = str_replace('@', '&#x40;', $email);
      $location = parsecontent(0, 0, 0, 0, $location);
      $homepage = parsecontent(0, 0, 0, 0, $homepage);
      $content = parsecontent(0, $use_smilies, $use_ubbcode, $parse_urls, $content);
      $comment = parsecontent(1, $use_smilies, $use_ubbcode, $parse_urls, $comment);

      // label
      echo '<a name="'.$anchor.'">&nbsp;</a><br />'.CR.
           '<table>'.CR.
           '  <tr>'.CR.
           '    <td class="title">'.$name;

      if (($open || $admin) && $email) echo '&nbsp;&nbsp;<a href="mailto:'.$email.'"><img class="button" src="img/mail.gif" width="14" height="17" border="0" alt="'.$email.'" title="'.$email.'" /></a>';
      if ($homepage) echo '&nbsp;&nbsp;<a href="'.$homepage.'" target="_blank"><img class="button" src="img/home.gif" width="14" height="17" border="0" alt="'.$homepage.'" title="'.$homepage.'" /></a>';
      if ($location) echo '&nbsp;&nbsp;<img class="button" src="img/location.gif" width="16" height="16" border="0" alt="'.$location.'" title="'.$location.'" />';

      echo '</td>'.CR.
           '    <td class="title" align="right">'.$datum;

      if ($admin || in_array($nr, $allowedit)) echo '&nbsp;&nbsp;<a href="message.php?page=edit&message='.$nr.'&start='.$start.'&anchor='.$anchor.'"><img class="button" src="img/edit.gif" width="18" height="17" border="0" alt="'.$LANG['edit'].'" title="'.$LANG['edit'].'" /></a>';
      if ($admin) echo '&nbsp;<a href="message.php?page=delete&message='.$nr.'&start='.$start.'&anchor='.$anchor.'"><img class="button" src="img/delete.gif" width="14" height="17" border="0" alt="'.$LANG['delete'].'" title="'.$LANG['delete'].'" /></a>';

      echo '</td>'.CR.
           '  </tr>'.CR.
           '  <tr>'.CR.
           '    <td colspan="2" class="content"><div class="noalfa"><br />'.CR.
           $content.'<br />';

      if ($ip && $log_ipaddress) {
        echo CR.'<div class="iplog">ip: ';
        if ($admin) echo $ip;
        else echo $LANG['logged'];
        echo '</div>';
      } else {
        echo '<br />';
      }

      if ($comment) {
        echo CR.'<div class="divider"></div>'.CR.
             '<span class="comment">'.$LANG['Comment'].':</span><br /><br />'.CR.
             $comment.'<br /><br />';
      }

      echo '</div></td>'.CR.
           '  </tr>'.CR.
           '</table>'.CR;

      flush(); 

    }

  } else { 

    echo '<b>'.$LANG['NoMessages'].'</b>'.CR;

  }

  echo '<br />';
  if ($navigation) {

    echo '<table class="noborder">'.CR.
         '  <tr>'.CR.
         '    <td class="nav">'.$navigation.'</td>'.CR.
         '  </tr>'.CR.
         '</table>'.CR;

  }

}

list($a_dec, $a_sec) = explode(' ', $start_time);
list($b_dec, $b_sec) = explode(' ', microtime());
$duration = $b_sec - $a_sec + $b_dec - $a_dec;
echo '<div class="iplog">'.$LANG['parsetime'].': '.sprintf('%0.3f', $duration).' '.$LANG['seconds'].'</div>'.CR;

include ('./inc/copyright.php');

?>
</body>
</html>