<?php

/*

J.A.G. (Just Another Guestbook) v1.14

Copyright (C) 2003 crisp - freesoftware@xs4all.nl

See full notice in guestbook.php

*/


include('./inc/smilies.php');
function parsecontent($use_html, $use_smilies, $use_ubbcode, $parse_urls, $content) {

  global $smilies;

  if ($use_ubbcode) preg_match_all('/\[pre\](.+)\[\/pre\]/Uis', $content, $prematches);

  if (!$use_html) {

    $content = htmlspecialchars($content);

    // replace ampersands not used in entities
    $content = preg_replace('/&amp;(#\d+|[a-z]+|#x[\da-f]);/Uis', '&$1;', $content);

  }

  $content = nl2br($content);

  if ($use_smilies) {

    foreach ($smilies as $smiley) {

      $smileycode = $smiley[0];
      if (!$use_html) $smileycode = htmlspecialchars($smileycode);
      $pattern = '/(?<!\S)'.preg_quote($smileycode, '/').'((?!\S)|(?=<br \/\>))/';
      $replace = '<img src="'.$smiley[1].'" width="'.$smiley[2].'" height="'.$smiley[3].'" border="0" alt="" />';
      $content = preg_replace($pattern, $replace, $content);

    }

  }

  if ($use_ubbcode) {

    $content = preg_replace('/\[b\](.+)\[\/b\]/Uis', '<b>$1</b>', $content);
    $content = preg_replace('/\[i\](.+)\[\/i\]/Uis', '<i>$1</i>', $content);
    $content = preg_replace('/\[s\](.+)\[\/s\]/Uis', '<s>$1</s>', $content);
    $content = preg_replace('/\[u\](.+)\[\/u\]/Uis', '<u>$1</u>', $content);
    $content = preg_replace('/\[li\](.+)\[\/li\](\<br \/\>)??/Uis', '<div style="margin-left: 20px; float: left; clear: left">&bull;&nbsp;&nbsp;</div><div style="float: left">$1</div><br />', $content);
    $content = preg_replace('/(\<br \/\>)?$/', '', $content);
    $content = preg_replace('/\[url\](http(s?):\/\/)??(.+)\[\/url\]/Ui', '<a href="http$2://$3" target="_blank">$3</a>', $content);
    $content = preg_replace('/\[url=(http(s?):\/\/)??(.+)\](.+)\[\/url\]/Ui', '<a href="http$2://$3" target="_blank">$4</a>', $content);
    $content = preg_replace('/\[img\](http:\/\/)??(.+)\[\/img\]/Ui', '<img src="http://$2" alt="" />', $content);
    $content = preg_replace('/\[img=([0-9]{1,3}),([0-9]{1,3})\](http:\/\/)??(.+)\[\/img\]/Ui', '<img src="http://$4" width="$1" height="$2" alt="" />', $content);
    $content = preg_replace('/\[mail\]([\w.]+)(@)([\w.]+)\[\/mail\]/Uis', '<a href="mailto:$1&#x40;$3">$1&#x40;$3</a>', $content);
    $content = preg_replace('/\[mail\](.+)\[\/mail\]/Uis', '<a href="mailto:$1">$1</a>', $content);

  }

  if ($parse_urls) {

    $content = preg_replace('/(?<!\S)([\w.]+)(@)([\w.]+)\b/i', '<a href="mailto:$1&#x40;$3">$1&#x40;$3</a>', $content);
    $content = preg_replace('/(?<!\S)((ftp(7?):\/\/)|(ftp\.))([\w.\/&=?\-~%;]+)\b/i', '<a href="ftp$3://$4$5" target="_blank">$4$5</a>', $content);
    $content = preg_replace('/(?<!\S)((http(s?):\/\/)|(www\.))+([\w.\/&=?\-~%;]+)\b/i', '<a href="http$3://$4$5" target="_blank">$4$5</a>', $content);

  }

  if ($use_ubbcode && count($prematches)) {

    $i=0;
    if ($use_html) {
      $content = preg_replace('/\[pre\](.+)\[\/pre\]/Uise', 'htmlspecialchars(\$prematches[1][\$i++])', $content);
    } else {
      $content = preg_replace('/\[pre\](.+)\[\/pre\]/Uise', '\$prematches[1][\$i++]', $content);
    }

  }

  return $content;

}

function stripenters($content) {

  $content = trim($content); // strip all whitespace at beginning and end of message
  $content = preg_replace('/\r\n|\n|\r/', "\n", $content); // cross platform linebreaks
  $content = preg_replace('/\040+(\n)/', '', $content); // strip whitespace until linebreak
  $content = preg_replace('/\040{2,}/', ' ', $content); // replace multiple spaces with 1
  $content = preg_replace('/\n{3,}/', "\n\n", $content); // replace multiple linebreaks by 2

  return $content;

}

?>