<?php

/*

J.A.G. (Just Another Guestbook) v1.14

Copyright (C) 2003 crisp - freesoftware@xs4all.nl

See full notice in guestbook.php

*/


@set_time_limit(600);

// Settings
include ('./inc/config.php');
include ('./inc/general.php');

// Language
$lang = $default_language;
if (isset($_SESSION['language'])) $lang = $_SESSION['language'];
include ('./lang/language_'.$lang.'.php');

$guestbook_id_chk = '';
if (isset($_POST['guestbook_id'])) $guestbook_id_chk = $_POST['guestbook_id'];

if (!isset($guestbook_id) || !$guestbook_id || $guestbook_id_chk != $guestbook_id) redirect('guestbook.php');

$error = '';
if (!$_FILES['backup']['tmp_name']) {

  $error .= '<b>'.$LANG['NoFile'].'</b><br />'.CR;

} else {

  if (is_uploaded_file($_FILES['backup']['tmp_name'])) {

    // check for any errors
    switch ($_FILES['backup']['error']) {

      case 0:
        break;
      case 1:
        $error .= '<b>'.$LANG['TooBig'].'</b><br />'.CR;
        break;
      case 2:
        $error .= '<b>'.$LANG['TooBig'].'</b><br />'.CR;
        break;
      case 3:
        $error .= '<b>'.$LANG['Partial'].'</b><br />'.CR;
        break;
      case 4:
        $error .= '<b>'.$LANG['NoFile'].'</b><br />'.CR;
        break;
      case 5:
        $error .= '<b>'.$LANG['Empty'].'</b><br />'.CR;
        break;

    }

    if (!$error) {

      // open file for reading
      $fp = @fopen($_FILES['backup']['tmp_name'], 'r');

      if (!$fp) {

        $error .= '<b>'.$LANG['NoOpen'].'</b><br />'.CR;

      } else if (!$conn_id = @mysql_connect($host, $id, $pw)) {

        $error .= '<b>'.$LANG['NoConn'].'</b><br />'.CR;  

      } else if (!@mysql_select_db($database, $conn_id)) {

        $error .= '<b>'.$LANG['NoDB'].'</b><br />'.CR;

      } else {

        $sql = '';
        while (!feof($fp)) {

          $read = fgets($fp, 4096);

          if (!preg_match('/^[#-]/', $read)) {

            $sql .= $read;

            if (preg_match('/;[\r\n]$/', $sql)) {

              $sql = preg_replace('/;[\r\n]$/', '', $sql);

              if (!@mysql_query($sql, $conn_id)) $error .= '<b>'.$LANG['QryFail'].':</b> '.htmlspecialchars($sql).'<br /><br />'.CR;
              $sql = '';

            }

          }

        }

      }

    }

  } else {

    $error = '<b>'.$LANG['Attack'].'</b><br />'.CR;

  }

}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- J.A.G. (Just Another Guestbook) v<?php echo $version; ?> - GNU Copyright (c) 2003 by crisp / freesoftware[at]xs4all.nl -->
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Pragma" content="no-cache">
<meta name="robots" content="noindex,nofollow">
<title><?php echo $guestbook_name.' - '.$LANG['restore']; ?></title>
<link rel="stylesheet" href="style/<?php echo $stylesheet; ?>" type="text/css">
</head>
<body>
<table>
  <tr>
    <td class="title"><a class="title" href="guestbook.php"><?php echo $LANG['Back']; ?></a></td>
  </tr>
</table><br />
<?php

if ($error) {

  echo $error.'<br />'.CR;

} else {

  echo '<b>'.$LANG['Success'].'</b><br /><br />'.CR;

}

include ('./inc/copyright.php');

?>
</body>
</html>