<?php

/*

J.A.G. (Just Another Guestbook) v1.14

Copyright (C) 2003 crisp - freesoftware@xs4all.nl

See full notice in guestbook.php

*/


// Settings
include ('./inc/config.php');
include ('./inc/general.php');
include ('./inc/parser.php');
include ('./inc/chkban.php');
include ('./inc/formatdate.php');

// Language
$lang = $default_language;
if (isset($_SESSION['language'])) $lang = $_SESSION['language'];
include ('./lang/language_'.$lang.'.php');

// init
$page = '';
$message = 0;
$start = 0;
$anchor = '';
$action = '';
$name = '';
$email = '';
$location = '';
$homepage = 'http://';
$open = '0';
$content = '';
$comment = '';
$ip = '';
$date = '';
$datestring = '';
$error = '';
$readonly = 0;
$lockdown = 0;
$time_error = 0;

$admin = 0;
if (isset($_SESSION['loggedin']) && $_SESSION['loggedin'] == $guestbook_id) $admin = 1;

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

  // Get POST vars
  if (isset($_POST['page'])) $page = $_POST['page'];
  if (isset($_POST['message'])) $message = $_POST['message'];
  if (isset($_POST['start'])) $start = $_POST['start'];
  if (isset($_POST['anchor'])) $anchor = $_POST['anchor'];
  if (isset($_POST['action'])) $action = $_POST['action'];
  if (isset($_POST['name'])) $name = $_POST['name'];
  if (isset($_POST['email'])) $email = $_POST['email'];
  if (isset($_POST['location'])) $location = $_POST['location'];
  if (isset($_POST['homepage'])) $homepage = $_POST['homepage'];
  if (isset($_POST['open'])) $open = $_POST['open'];
  if (isset($_POST['content'])) $content = $_POST['content'];
  if ($admin) {
    if (isset($_POST['comment'])) $comment = $_POST['comment'];
    if (isset($_POST['ip'])) $ip = $_POST['ip'];
    if (isset($_POST['datum'])) $date = $_POST['datum'];
    if (isset($_POST['datestring'])) $datestring = $_POST['datestring'];
  }

  if (!get_magic_quotes_gpc()) {

    $name = addslashes($name);
    $email = addslashes($email);
    $location = addslashes($location);
    $homepage = addslashes($homepage);
    $open = addslashes($open);
    $content = addslashes($content);
    $comment = addslashes($comment);
    $ip = addslashes($ip);
    $date = addslashes($date);

  }

} else {

  // Get GET vars
  if (isset($_GET['page'])) $page = $_GET['page'];
  if (isset($_GET['start'])) $start = $_GET['start'];
  if (isset($_GET['anchor'])) $anchor = $_GET['anchor'];
  if (isset($_GET['message'])) $message = $_GET['message'];

}

// Make connection
$conn_id = mysql_connect($host, $id, $pw);
mysql_select_db($database, $conn_id);

// check ip
$checkip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];

if (($page != 'new' && $page != 'edit' && $page != 'delete') || (!$admin && ($readonly || $lockdown || checkban($checkip, $conn_id)))) {

  redirect('guestbook.php');

}

if ($page == 'edit' || $page == 'delete') {

  $returnpath = 'guestbook.php?start='.$start;
  if ($anchor) $returnpath .= '&#'.$anchor;

  if (!$message) redirect($returnpath);

  if (!$admin && $page == 'delete') redirect('admin.php?returnpath='.htmlspecialchars(urlencode('message.php?'.$_SERVER['QUERY_STRING'])));

  // Retrieve array of messages user is allowed to edit
  $allowedit = array();
  if ($allow_edit && isset($_SESSION['editid'])) $allowedit = $_SESSION['editid'];

  if (!$admin && !in_array($message, $allowedit)) redirect('admin.php?returnpath='.htmlspecialchars(urlencode('message.php?'.$_SERVER['QUERY_STRING'])));

  if ($action == 'save') {

    if ($page == 'edit') {

      // validations
      if ($email && !preg_match('/^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+\.)+[a-zA-Z]{2,4}$/', $email)) $error .= '<b>'.$LANG['InvEmail'].'</b><br />'.CR;
      if (!preg_match('/\S+/', $content)) $error .= '<b>'.$LANG['NoMessage'].'</b><br />'.CR;
      if (!$admin && strlen($content) > $max_content_length) $error .= '<b>'.$LANG['Flood'].'</b><br />'.CR;
      if ($admin && $ip && !preg_match('/^[1-9][0-9]{0,2}\.(0\.|[1-9][0-9]{0,2}\.){2}(0|[1-9][0-9]{0,2})$/', $ip)) $error .= '<b>'.$LANG['InvIP'].'</b><br />'.CR;

      // try to parse the datestring
      if ($datestring) {

        $newdate = checkdatetime($datestring);
        if ($newdate == -1) {

          $error .= '<b>'.$LANG['InvalidDate'].'</b><br />'.CR;

        } else {

          $date = $newdate-$timeshift*3600;

        }

      }

      if (!$error) {

        if (!$admin) {

          $result = mysql_query('select ip, comment, datum from '.$table.' where nr = '.$message, $conn_id); 
          $row = mysql_fetch_assoc($result);
          $ip = $row['ip'];
          $comment = $row['comment'];
          $date = $row['datum'];

        }

        $name = ($name) ? $name : $LANG['Anonymous'];
        if (!$email) $open = '0';
        if (!$date) $date = time();
        if ($homepage == 'http://') $homepage = '';
        else $homepage = preg_replace('/(http:\/\/)?(.+)/', 'http://$2', $homepage);
        if (!$ip && $log_ipaddress) $ip = $checkip;

        // strip extra enters and spaces
        $content = stripenters($content);
        $comment = stripenters($comment);

        mysql_query('update '.$table.' set name = "'.$name.'", email = "'.$email.'", location = "'.$location.'", homepage = "'.$homepage.'", open = "'.$open.'", ip = "'.$ip.'", content = "'.$content.'", comment = "'.$comment.'", datum = '.$date.' where nr = '.$message, $conn_id);

        redirect($returnpath);

      }

    }

    if ($page == 'delete') {

      mysql_query('delete from '.$table.' where nr = '.$message, $conn_id); 

      redirect($returnpath);

    }

  } else if ($action == 'ban' && $admin) {

      mysql_query('insert into '.$table_bl.' (ip, name, datum) values ("'.$ip.'", "'.$_SESSION['curuser'].'", '.time().')', $conn_id);

  } else if ($action != 'preview') {

    // Get message details
    $result = mysql_query('select * from '.$table.' where nr = '.$message, $conn_id); 

    if (mysql_num_rows($result)) {

      $row = mysql_fetch_assoc($result);
      $name = $row['name'];
      $email = $row['email'];
      $location = $row['location'];
      $homepage = $row['homepage'];
      $content = $row['content'];
      $comment = $row['comment'];
      $open = $row['open'];
      $ip = $row['ip'];
      $date = $row['datum'];
      $datestring = date('Y-m-d H:i:s', $date+$timeshift*3600);

    } else {

      $error .= '<b>'.$LANG['NoMsg'].'</b><br />'.CR;
      $time_error = 1;

    }

  }

} else {

  if (!$admin && $time_limit && isset($_SESSION['time_last_message'])) {

    if (time() - $_SESSION['time_last_message'] < $time_limit) {

      $time_error = 1;
      $error .= '<b>'.$LANG['TimeError'].'</b>';

    }

  }

  if ($action == 'save' && !$time_error) {

    // validations
    if ($email && !preg_match('/^[_a-zA-Z0-9-]+(\.[_a-zA-Z0-9-]+)*@([a-zA-Z0-9-]+\.)+[a-zA-Z]{2,4}$/', $email)) $error .= '<b>'.$LANG['InvEmail'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $content)) $error .= '<b>'.$LANG['NoMessage'].'</b><br />'.CR;
    if (!$admin && strlen($content) > $max_content_length) $error .= '<b>'.$LANG['Flood'].'</b><br />'.CR;

    if (!$error) {

      $name = ($name) ? $name : $LANG['Anonymous'];
      if ($log_ipaddress) $ip = $checkip;
      if (!$email) $open = '0';
      if (!$date) $date = time();
      if ($homepage == 'http://') $homepage = '';
      else $homepage = preg_replace('/(http:\/\/)?(.+)/', 'http://$2', $homepage);

      // strip extra enters
      $content = stripenters($content);
      $comment = stripenters($comment);

      if (@mysql_query('insert into '.$table.' (name, email, location, homepage, open, ip, content, comment, datum) values ("'.$name.'", "'.$email.'", "'.$location.'", "'.$homepage.'", "'.$open.'", "'.$ip.'", "'.$content.'", "'.$comment.'", '.$date.')', $conn_id)) {

        $nr = mysql_insert_id($conn_id);
        $allowedit = isset($_SESSION['editid'])? $_SESSION['editid']:array();
        array_push ($allowedit, $nr);
        $_SESSION['editid'] = $allowedit;

        if ($time_limit) $_SESSION['time_last_message'] = time();

        // sent notification mail
        if ($email_notification) {

          // sent mail in default language
          include ('./lang/language_'.$default_language.'.php');

          if ($email) $email = 'mailto:'.stripslashes($email);
          $mailheader  = 'From: "'.$guestbook_name.'"<'.$MAIL['NoReply'].'>'.CRLF.
                         'X-Sender: <'.$MAIL['NoReply'].'>'.CRLF.
                         'X-Mailer: JAG guestbook'.CRLF.
                         'X-Priority: 3'.CRLF.
                         'Return-Path: <'.$MAIL['NoReply'].'>'.CRLF;
          $subject = $MAIL['Subject'];
          $mailcontent = $LANG['name'].': '.stripslashes($name).CR.
                         $LANG['email'].': '.$email.CR.
                         $LANG['location'].': '.$location.CR.
                         $LANG['homepage'].': '.stripslashes($homepage).CR.
                         $LANG['message'].': '.stripslashes($content).CR.CR.CR.
                         $LANG['datetime'].': '.formatdate($date, $datetimeformat, $timeshift).CR.
                         $LANG['ip'].': '.$ip.CR.CR.CR.
                         $MAIL['Edit'].': http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?page=edit&message='.$nr.CR.
                         $MAIL['Delete'].': http://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?page=delete&message='.$nr.CR.CR.CR.
                         'J.A.G. (Just Another Guestbook) v'.$version;

          foreach ($notification_to as $recipient) {

            mail($recipient, $subject, $mailcontent, $mailheader);

          }

        }

        redirect('guestbook.php');

      } else {

        $error .= '<b>'.$LANG['Ooops'].'</b><br />'.CR;

      }

    }

  }

}

function checkdatetime($datestring) {

  if (!preg_match_all('/^(\d{1}|\d{2}|\d{4})-(\d{1,2})-(\d{1,2})\040(\d{1,2}):(\d{1,2}):(\d{1,2})$/', $datestring, $d)) return -1;

  if (!checkdate($d[2][0], $d[3][0], $d[1][0])) return -1;
  if ($d[4][0] < 0 || $d[4][0] > 23) return -1;
  if ($d[5][0] < 0 || $d[5][0] > 59) return -1;
  if ($d[6][0] < 0 || $d[6][0] > 59) return -1;

  return strtotime($datestring);

}

$legend = (($use_smilies && $smilie_legend) || ($use_ubbcode && $ubbcode_legend))? 1:0;
$disabled = ($page == 'delete')? 'disabled ':'';

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- J.A.G. (Just Another Guestbook) v<?php echo $version; ?> - GNU Copyright (c) 2003 by crisp / freesoftware[at]xs4all.nl -->
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Pragma" content="no-cache">
<meta name="robots" content="noindex,nofollow">
<base target="_self">
<title><?php echo $guestbook_name.' - '.$ACTION[$page]; ?></title>
<link rel="stylesheet" href="style/<?php echo $stylesheet; ?>" type="text/css">
<?php

if (!$time_error) {

  if ($legend) echo '<script type="text/javascript" src="js/codes.js"></script>'.CR;

  echo '<script type="text/javascript">'.CR;

  if ($use_ubbcode && $ubbcode_legend) {

    echo CR.'var prompttext = new Array();'.CR.
            'prompttext[\'img\'] = \''.$LANG['img'].'\';'.CR.
            'prompttext[\'b\'] = \''.$LANG['b'].'\';'.CR.
            'prompttext[\'i\'] = \''.$LANG['i'].'\';'.CR.
            'prompttext[\'s\'] = \''.$LANG['s'].'\';'.CR.
            'prompttext[\'u\'] = \''.$LANG['u'].'\';'.CR.
            'prompttext[\'li\'] = \''.$LANG['li'].'\';'.CR.
            'prompttext[\'url\'] = \''.$LANG['url'].'\';'.CR.
            'prompttext[\'url=\'] = \''.$LANG['url'].'\';'.CR.
            'prompttext[\'urld\'] = \''.$LANG['urld'].'\';'.CR.
            'prompttext[\'mail\'] = \''.$LANG['mail'].'\';'.CR;

  }

?>

function altaction(action) {

  document.forms['message'].elements['action'].value = action;
  document.forms['message'].submit();

}

</script>
<?php

}  // $time_error

echo '</head>'.CR.
     '<body';

if (!$time_error && !$disabled) {

  echo ' onload="document.forms[\'message\'].elements[\'name\'].focus();';
  if ($legend) echo 'getTarget(\'content\');" onunload="if (popup) popup.close();';
  echo '"';

}

echo '>'.CR.
     '<table>'.CR.
     '  <tr>'.CR.
     '    <td class="title"><a class="title" href="guestbook.php">'.$LANG['Back'].'</a></td>'.CR.
     '  </tr>'.CR.
     '</table><br />'.CR;

if (!$time_error && ($error || $action == 'preview')) {

  $name = stripslashes($name);
  $email = stripslashes($email);
  $location = stripslashes($location);
  $homepage = stripslashes($homepage);
  $open = stripslashes($open);
  $content = stripslashes($content);
  $comment = stripslashes($comment);
  $ip = stripslashes($ip);
  $date = stripslashes($date);

}

if ($error) {

  echo $error.'<br />'.CR;

} else if ($action == 'preview') {

  echo '<table>'.CR.
       '  <tr>'.CR.
       '    <td class="title">'.$LANG['Preview'].'</td>'.CR.
       '  </tr>'.CR.
       '  <tr>'.CR.
       '    <td class="content"><div class="noalfa"><br />'.CR.
       parsecontent(0, $use_smilies, $use_ubbcode, $parse_urls, stripenters($content)).'<br /><br />';

  if ($comment) {

    echo CR.'<div class="divider"></div>'.CR.
         '<span class="comment">'.$LANG['Comment'].':</span><br /><br />'.CR.
         parsecontent(1, $use_smilies, $use_ubbcode, $parse_urls, stripenters($comment)).'<br /><br />';

  }

  echo '</div></td>'.CR.
       '  </tr>'.CR.
       '</table><br />'.CR;

} else if ($admin && $page == 'new') {

  $name = $_SESSION['curuser'];
  if ($webmaster_email) $email = $webmaster_email;
  if ($site_homepage) $homepage = $site_homepage;

}

if (!$time_error) {

  echo '<table style="table-layout: auto">'.CR.
       '  <tr>'.CR.
       '    <td width="480" class="content"><div class="noalfa">'.CR.
       '      <form name="message" action="message.php" method="post">'.CR.
       '        <table class="noborder">'.CR.
       '          <tr>'.CR.
       '            <td width="80"><br /></td>'.CR.
       '            <td width="400"><br /></td>'.CR.
       '          </tr>'.CR.
       '          <tr>'.CR.
       '            <td valign="top">'.$LANG['name'].':</td>'.CR.
       '            <td><input type="text" name="name" value="'.htmlspecialchars($name).'" size="30" maxlength="30" style="width: 224px; height:22px" '.$disabled.'/></td>'.CR.
       '          </tr>'.CR.
       '          <tr>'.CR.
       '            <td valign="top">'.$LANG['email'].':</td>'.CR.
       '            <td><input type="text" name="email" value="'.htmlspecialchars($email).'" size="40" maxlength="50" style="width: 294px; height:22px" '.$disabled.'/></td>'.CR.
       '          </tr>'.CR.
       '          <tr>'.CR.
       '            <td valign="top">'.$LANG['location'].':</td>'.CR.
       '            <td><input type="text" name="location" value="'.htmlspecialchars($location).'" size="40" maxlength="50" style="width: 294px; height:22px" '.$disabled.'/></td>'.CR.
       '          </tr>'.CR.
       '          <tr>'.CR.
       '            <td valign="top">'.$LANG['homepage'].':</td>'.CR.
       '            <td><input type="text" name="homepage" value="'.htmlspecialchars($homepage).'" size="40" maxlength="50" style="width: 294px; height:22px" '.$disabled.'/></td>'.CR.
       '          </tr>'.CR.
       '          <tr>'.CR.
       '            <td valign="top">'.$LANG['message'].':</td>'.CR.
       '            <td><textarea id="content" name="content" rows="9" cols="45" style="width: 384px; height: 150px"';

  if ($legend && !$disabled) echo ' onfocus="getTarget(\'content\')" onselect="storeCursor(this)" onkeyup="storeCursor(this)" onclick="storeCursor(this)"';
  echo $disabled.'>'.htmlspecialchars($content).'</textarea></td>'.CR.
       '          </tr>'.CR;

  if ($admin && (!$disabled || $comment)) {

    echo '          <tr>'.CR.
         '            <td valign="top">'.$LANG['comment'].':</td>'.CR.
         '            <td><textarea id="comment" name="comment" rows="9" cols="45" style="width: 384px; height: 150px"';
    if ($legend && !$disabled) echo ' onfocus="getTarget(\'comment\')" onselect="storeCursor(this)" onkeyup="storeCursor(this)" onclick="storeCursor(this)"';
    echo $disabled.'>'.htmlspecialchars($comment).'</textarea></td>'.CR.
         '          </tr>'.CR;

  }

  if (($page == 'edit' || $page == 'delete') && $admin) {

    echo '          <tr>'.CR.
         '            <td valign="top">'.$LANG['ip'].':</td>'.CR.
         '            <td><input type="text" name="ip" value="'.htmlspecialchars($ip).'" size="20" maxlength="15" style="width: 154px; height:22px" '.$disabled.'/>&nbsp;XXX.XXX.XXX.XXX&nbsp;&nbsp;';

    if (checkban($ip, $conn_id)) echo '<span class="comment">'.$LANG['banned'].'</span>';
    else echo '<input type="button" value="'.$ACTION['ban'].'" onclick="altaction(\'ban\')" />';

    echo '</td>'.CR.
         '          </tr>'.CR.
         '          <tr>'.CR.
         '            <td valign="top">'.$LANG['datetime'].':</td>'.CR.
         '            <td><input type="text" name="datestring" value="'.htmlspecialchars($datestring).'" size="20" maxlength="20" style="width: 154px; height:22px" '.$disabled.'/>&nbsp;YYYY-MM-DD HH:MM:SS</td>'.CR.
         '          </tr>'.CR;

  }

  echo '          <tr>'.CR.
       '            <td valign="top" colspan="2"><input type="checkbox" name="open" value="1"';

  if (($page=='new' && $dft_showemail) || $open=='1') echo ' checked="checked"';

  echo ' '.$disabled.'/>&nbsp;'.$LANG['showemail'].'<br /></td>'.CR.
       '          </tr>'.CR.
       '          <tr>'.CR.
       '            <td></td>'.CR.
       '            <td valign="top"><br />';

  if (!$disabled) echo '<input type="button" value="'.$ACTION['preview'].'" onclick="altaction(\'preview\')" />&nbsp;&nbsp;';

  echo '<input type="submit" value="'.$ACTION[$page].'" /></td>'.CR.
       '          </tr>'.CR.
       '        </table>'.CR;

  if ($admin) echo '        <input type="hidden" name="datum" value="'.$date.'" />'.CR;

  echo '        <input type="hidden" name="message" value="'.$message.'" />'.CR.
       '        <input type="hidden" name="page" value="'.$page.'" />'.CR.
       '        <input type="hidden" name="start" value="'.$start.'" />'.CR.
       '        <input type="hidden" name="anchor" value="'.$anchor.'" />'.CR.
       '        <input type="hidden" name="action" value="save" />'.CR.
       '      </form>'.CR.
       '    </div><br /></td>'.CR;

  if ($legend) {

    $legend_title_string = '';
    if ($use_smilies && $smilie_legend) {

      $legend_title_string .= $LANG['Smilies'];
      if ($use_ubbcode && $ubbcode_legend) $legend_title_string .= ' &amp; ';

    }
    if ($use_ubbcode && $ubbcode_legend) $legend_title_string .= $LANG['UBBcodes'];

    if ($legend_placement != 'right') echo '  </tr>'.CR.'  <tr>'.CR;

    echo '    <td valign="top" class="content"><div class="noalfa">';

    if ($legend_placement == 'popup') {

      $popupwidth = $smilie_legend_width + 30;
      if ($popupwidth < 300 && $use_ubbcode && $ubbcode_legend) $popupwidth = 300;
      echo CR.'<a href="javascript://" onclick="openwin(\'codepopup.php\', \'codepopup\', 400, '.$popupwidth.');return false;">'.$legend_title_string.' ('.$LANG['popup'].')</a><br /><br />'.CR;

    } else {

      if ($legend_placement == 'right') echo '<br />';

      if ($legend_title) echo $legend_title_string.' ('.$LANG['clickable'].'):<br /><br />'.CR;

      if ($use_smilies && $smilie_legend) writesmilies($smilie_legend_width, $smilie_legend_keycodes, '');
      if ($use_ubbcode && $ubbcode_legend) writeubbcodes('');

    }

    echo '    </div></td>'.CR;

  }

  echo '  </tr>'.CR.
       '</table>'.CR;

} // $time_error

echo '<br />'.CR;

include ('./inc/copyright.php');

?>
</body>
</html>