<?php

/*

J.A.G. (Just Another Guestbook) v1.14

Copyright (C) 2003 crisp - freesoftware@xs4all.nl

See full notice in guestbook.php

*/


// initialise fields (defaults)
$version = 0;
$curversion = 1.14;
$guestbook_name = 'J.A.G. (Just Another Guestbook)';
$guestbook_id = 'JAG';
$webmaster_email = '';
$site_homepage = '';
$stylesheet = 'default.css';
$messages_per_page = 10;
$navlength = 9;
$use_smilies = 1;
$smilie_legend = 1;
$smilie_legend_keycodes = 1;
$smilie_legend_width = 250;
$use_ubbcode = 1;
$ubbcode_legend = 1;
$legend_placement = 'right';
$legend_title = 1;
$parse_urls = 1;
$log_ipaddress = 1;
$dft_showemail = 1;
$datetimeformat = 'd-m-Y H:i:s';
$timeshift = 0;
$max_content_length = 4000;
$time_limit = 60;
$allow_edit = 1;
$email_notification = 0;
$notification_to = array();
$avail_languages = array('en' => 'English');
$default_language = 'en';
$id = '';
$pw = '';
$host = 'localhost';
$database = '';
$table = 'guestbook';
$table_bl = 'banlist';
$adminpwd = array();
$readonly = 0;
$lockdown = 0;
$lock_msg = '';

// Settings
@include ('./inc/config.php');
include ('./inc/general.php');
$error = '';

// Backwards compatibility for selected languages
if (isset($avail_languages[0])) {
  $default_language = $avail_languages[0];
  $avail_languages = array_flip($avail_languages);
}

// Language
$lang = $default_language;
if (isset($_SESSION['language'])) $lang = $_SESSION['language'];
include ('./lang/language_'.$lang.'.php');

// check for admin
$admin = 0;
if (isset($_SESSION['loggedin']) && $_SESSION['loggedin'] == $guestbook_id) $admin = 1;

if (!$admin && !empty($adminpwd)) redirect('admin.php?returnpath=setup.php');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {

  // Get POST vars
  $guestbook_name = isset($_POST['guestbook_name'])? $_POST['guestbook_name']:'';
  $webmaster_email = isset($_POST['webmaster_email'])? $_POST['webmaster_email']:'';
  $site_homepage = isset($_POST['site_homepage'])? $_POST['site_homepage']:'';
  $stylesheet = isset($_POST['stylesheet'])? $_POST['stylesheet']:'';
  $messages_per_page = isset($_POST['messages_per_page'])? $_POST['messages_per_page']:0;
  $navlength = isset($_POST['navlength'])? $_POST['navlength']:0;
  $use_smilies = isset($_POST['use_smilies'])? $_POST['use_smilies']:0;
  $smilie_legend = isset($_POST['smilie_legend'])? $_POST['smilie_legend']:0;
  $smilie_legend_keycodes = isset($_POST['smilie_legend_keycodes'])? $_POST['smilie_legend_keycodes']:0;
  $smilie_legend_width = isset($_POST['smilie_legend_width'])? $_POST['smilie_legend_width']:0;
  $use_ubbcode = isset($_POST['use_ubbcode'])? $_POST['use_ubbcode']:0;
  $ubbcode_legend = isset($_POST['ubbcode_legend'])? $_POST['ubbcode_legend']:0;
  $legend_placement = isset($_POST['legend_placement'])? $_POST['legend_placement']:'';
  $legend_title = isset($_POST['legend_title'])? $_POST['legend_title']:0;
  $parse_urls = isset($_POST['parse_urls'])? $_POST['parse_urls']:0;
  $log_ipaddress = isset($_POST['log_ipaddress'])? $_POST['log_ipaddress']:0;
  $dft_showemail = isset($_POST['dft_showemail'])? $_POST['dft_showemail']:0;
  $datetimeformat = isset($_POST['datetimeformat'])? $_POST['datetimeformat']:'';
  $timeshift = isset($_POST['timeshift'])? $_POST['timeshift']:0;
  $max_content_length = isset($_POST['max_content_length'])? $_POST['max_content_length']:0;
  $time_limit = isset($_POST['time_limit'])? $_POST['time_limit']:0;
  $allow_edit = isset($_POST['allow_edit'])? $_POST['allow_edit']:0;
  $email_notification = isset($_POST['email_notification'])? $_POST['email_notification']:0;
  $notification_to = isset($_POST['notification_to'])? $_POST['notification_to']:array();
  $i = 0;
  while ($i < count($notification_to)) {
    if (!preg_match('/\S/', $notification_to[$i])) array_splice($notification_to, $i, 1);
    else $i++;
  }
  $languages = isset($_POST['languages'])? $_POST['languages']:array();
  $avail_languages = array_flip($languages);
  $default_language = isset($_POST['default_language'])? $_POST['default_language']:'';
  $id = isset($_POST['id'])? $_POST['id']:'';
  $pw = isset($_POST['pw'])? $_POST['pw']:'';
  $host = isset($_POST['host'])? $_POST['host']:'';
  $database = isset($_POST['database'])? $_POST['database']:'';
  $table = isset($_POST['table'])? $_POST['table']:'';
  $table_bl = isset($_POST['table_bl'])? $_POST['table_bl']:'';
  $adminname = isset($_POST['adminname'])? $_POST['adminname']:array();
  $adminpwds = isset($_POST['adminpwds'])? $_POST['adminpwds']:array();
  $readonly = isset($_POST['readonly'])? $_POST['readonly']:0;
  $lockdown = isset($_POST['lockdown'])? $_POST['lockdown']:0;
  $lock_msg = isset($_POST['lock_msg'])? $_POST['lock_msg']:'';
  $action = isset($_POST['action'])? $_POST['action']:'';

  if (!get_magic_quotes_gpc()) {

    $guestbook_name = addslashes($guestbook_name);
    $webmaster_email = addslashes($webmaster_email);
    $site_homepage = addslashes($site_homepage);
    $datetimeformat = addslashes($datetimeformat);
    $notification_to = array_map('addslashes', $notification_to);
    $id = addslashes($id);
    $pw = addslashes($pw);
    $host = addslashes($host);
    $database = addslashes($database);
    $table = addslashes($table);
    $table_bl = addslashes($table_bl);
    $adminname = array_map('addslashes', $adminname);
    $adminpwds = array_map('addslashes', $adminpwds);
    $lock_msg = addslashes($lock_msg);

  }

  $adminpwd = array();
  for ($i = 0, $tot = count($adminname); $i < $tot; $i++) {
    if (preg_match('/\S/', $adminname[$i])) $adminpwd[$adminname[$i]] = $adminpwds[$i];
  }

  if ($action == 'save') {

    // check validity
    if (!preg_match('/\S+/', $guestbook_name)) $error .= '<b>'.$LANG['NoName'].'</b><br />.CR';
    if (!preg_match('/^[1-9][0-9]*$/', $messages_per_page)) $error .= '<b>'.$LANG['MsgPage'].'</b><br />'.CR;
    if (!preg_match('/^[1-9][0-9]*$/', $navlength)) $error .= '<b>'.$LANG['NavLength'].'</b><br />'.CR;
    if (!preg_match('/^[1-9][0-9]*$/', $smilie_legend_width)) $error .= '<b>'.$LANG['LegWidth'].'</b><br />'.CR;
    if (!preg_match('/^[0-9]+$/', $time_limit)) $error .= '<b>'.$LANG['TimeLimit'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $datetimeformat)) $error .= '<b>'.$LANG['NoDTF'].'</b><br />'.CR;
    if (!preg_match('/^[+-]?[0-9]+$/', $timeshift)) $error .= '<b>'.$LANG['TimeShift'].'</b><br />'.CR;
    if (!preg_match('/^[1-9][0-9]*$/', $max_content_length)) $error .= '<b>'.$LANG['MsgLength'].'</b><br />'.CR;
    if ($email_notification && empty($notification_to)) $error .= '<b>'.$LANG['NoEmail'].'</b><br />'.CR;
    if (empty($avail_languages)) $error .= '<b>'.$LANG['NoLang'].'</b><br />'.CR;
    if (empty($default_language)) $error .= '<b>'.$LANG['NoDFTLang'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $id)) $error .= '<b>'.$LANG['NoID'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $pw)) $error .= '<b>'.$LANG['NoPW'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $host)) $error .= '<b>'.$LANG['NoHost'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $database)) $error .= '<b>'.$LANG['NoDatabase'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $table)) $error .= '<b>'.$LANG['NoTablename'].'</b><br />'.CR;
    if (!preg_match('/\S+/', $table_bl)) $error .= '<b>'.$LANG['NoTablenam2'].'</b><br />'.CR;
    if (empty($adminpwd)) $error .= '<b>'.$LANG['NoAdmin'].'</b><br />'.CR;
    foreach ($adminpwd as $adminname => $adminpass) {
      if (!preg_match('/\S+/', $adminpass)) $error .= '<b>'.str_replace('$adminname', $adminname, $LANG['NoAdminPwd']).'</b><br />'.CR;
    }
    if ($lockdown && !preg_match('/\S+/', $lock_msg)) $error .= '<b>'.$LANG['LockMsg'].'</b><br />'.CR;

    if (!$error) {

      // check connection to mySQL and existance of database and table (create if not exist).
      if (!@$conn_id = mysql_connect($host, $id, $pw)) {
        $error .= '<b>'.$LANG['InvConn'].'</b><br />'.CR;
      } else {
        if (!@mysql_select_db($database, $conn_id)) {
          // try to create
          if (!@mysql_create_db($database, $conn_id)) {
            $error .= '<b>'.str_replace('$database', $database, $LANG['InvDB']).'</b><br />'.CR;
          } else {
            @mysql_select_db($database, $conn_id);
            $error .= create_tables('guestbook', $table, $conn_id);
            $error .= create_tables('banlist', $table_bl, $conn_id);
          }
        } else {
          if (!@mysql_query('select count(*) from '.$table, $conn_id)) {
            $error .= create_tables('guestbook', $table, $conn_id);
          } elseif ($version) {
            $error .= alter_tables('guestbook', $table, $conn_id);
          }
          if (!@mysql_query('select count(*) from '.$table_bl, $conn_id)) {
            $error .= create_tables('banlist', $table_bl, $conn_id);
          } elseif ($version) {
            $error .= alter_tables('banlist', $table_bl, $conn_id);
          }
        }
      }

    }

    if (!$error) {

      // Create new guestbook_id
      $passwordChars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
      $guestbook_id = '';
      mt_srand ((double) microtime() * 1000000); 

      for ($i = 0; $i < 32; $i++) {

        // pick random number
        $random = rand(1, strlen($passwordChars));

        $guestbook_id .= substr($passwordChars, $random-1, 1);

      }

      // write new config file
      $content = '<?php'.CRLF.CRLF.
                 '/*'.CRLF.CRLF.
                 'J.A.G. (Just Another Guestbook) v'.$curversion.CRLF.CRLF.
                 'Copyright (C) 2003 crisp - freesoftware@xs4all.nl'.CRLF.CRLF.
                 'See full notice in guestbook.php'.CRLF.CRLF.
                 '*/'.CRLF.CRLF.
                 CRLF.'// Current Version'.CRLF.
                 '$version = '.$curversion.';'.CRLF.
                 CRLF.'// Guestbook'.CRLF.
                 '$guestbook_name = \''.$guestbook_name.'\';'.CRLF.
                 '$guestbook_id = \''.$guestbook_id.'\';'.CRLF.
                 '$webmaster_email = \''.$webmaster_email.'\';'.CRLF.
                 '$site_homepage = \''.$site_homepage.'\';'.CRLF.
                 '$stylesheet = \''.$stylesheet.'\';'.CRLF.
                 CRLF.'// General Settings'.CRLF.
                 '$messages_per_page = '.$messages_per_page.';'.CRLF.
                 '$navlength = '.$navlength.';'.CRLF.
                 '$use_smilies = '.$use_smilies.';'.CRLF.
                 '$smilie_legend = '.$smilie_legend.';'.CRLF.
                 '$smilie_legend_keycodes = '.$smilie_legend_keycodes.';'.CRLF.
                 '$smilie_legend_width = '.$smilie_legend_width.';'.CRLF.
                 '$use_ubbcode = '.$use_ubbcode.';'.CRLF.
                 '$ubbcode_legend = '.$ubbcode_legend.';'.CRLF.
                 '$legend_placement = \''.$legend_placement.'\';'.CRLF.
                 '$legend_title = '.$legend_title.';'.CRLF.
                 '$parse_urls = '.$parse_urls.';'.CRLF.
                 '$log_ipaddress = '.$log_ipaddress.';'.CRLF.
                 '$dft_showemail = '.$dft_showemail.';'.CRLF.
                 '$datetimeformat = \''.$datetimeformat.'\';'.CRLF.
                 '$timeshift = '.$timeshift.';'.CRLF.
                 '$max_content_length = '.$max_content_length.';'.CRLF.
                 '$time_limit = '.$time_limit.';'.CRLF.
                 '$allow_edit = '.$allow_edit.';'.CRLF.
                 '$email_notification = '.$email_notification.';'.CRLF.
                 '$notification_to = array(';
      for ($i = 0, $tot = count($notification_to); $i < $tot; $i++) {
        if ($i) $content .= ', ';
        $content .= '\''.$notification_to[$i].'\'';
      }
      $content .= ');'.CRLF.
                 '$avail_languages = array(';
      for ($i = 0, $tot = count($languages); $i < $tot; $i++) {
        if ($i) $content .= ','.CRLF.'                         ';
        $content .= '\''.$languages[$i].'\' => \''.get_language_name($languages[$i]).'\'';
      }
      $content .= ');'.CRLF.
                 '$default_language = \''.$default_language.'\';'.CRLF.
                 CRLF.'// Database Settings'.CRLF.
                 '$id = \''.$id.'\';   // Userid for SQL server'.CRLF.
                 '$pw = \''.$pw.'\';   // Password for SQL server'.CRLF.
                 '$host = \''.$host.'\';   // Host (\'localhost\' or \'IP-address\')'.CRLF.
                 '$database = \''.$database.'\';   // Name of the database'.CRLF.
                 '$table = \''.$table.'\';   // Table name for guestbook'.CRLF.
                 '$table_bl = \''.$table_bl.'\';   // Table name for banlist'.CRLF.
                 CRLF.'// Login data (name, password)'.CRLF.
                 '$adminpwd = array(';
      $adminname = array_keys($adminpwd);
      for ($i = 0, $tot = count($adminname); $i < $tot; $i++) {
        if ($i) $content .= ','.CRLF.'                  ';
        $content .= '\''.$adminname[$i].'\' => \''.$adminpwd[$adminname[$i]].'\'';
      }
      $content .= ');'.CRLF;
      if ($readonly || $lockdown) {
        $content .= CRLF.'// Security measures'.CRLF;
        if ($lockdown) {
          $content .= '$lockdown = '.$lockdown.';'.CRLF.
                      '$lock_msg = \''.$lock_msg.'\';'.CRLF;
        } else {
          $content .= '$readonly = '.$readonly.';'.CRLF;
        }
      }
      $content .= CRLF.'?>';

      $fp = @fopen('./inc/config.php', 'w');
      if (!$fp) {

        $error .= '<b>'.$LANG['NoWrite'].'</b><br />'.CR;

      } else {

        fputs($fp, $content);
        fclose($fp);

        // make sure we stay logged in
        $_SESSION['loggedin'] = $guestbook_id;

        redirect('guestbook.php');

      }

    }

  }

}

function create_tables($id, $table, $conn_id) {

  $tables = array('guestbook' => ' (nr int(11) not null auto_increment, name varchar(30), email varchar(50), location varchar(50), homepage varchar(50), open enum("0", "1"), ip varchar(15), content text, comment text, datum int(11), primary key (nr))',
                  'banlist'   => ' (ip varchar(15) not null, name varchar(30), datum int(11), primary key (ip))');

  $query = 'create table '.$table.$tables[$id];

  if (!@mysql_query($query, $conn_id)) return '<b>'.str_replace('$table', $table, $LANG['InvTable']).'</b><br />'.CR;

  return;

}

function alter_tables($id, $table, $conn_id) {

  global $version;

  // table upgrades; guestbook
  if ($id == 'guestbook') {

    // table upgrade for 1.14: add location field in guestbook table
    if ($version < 1.14) {

      $query = 'alter table '.$table.' add column location varchar(50) after email';
      if (!@mysql_query($query, $conn_id)) return '<b>Unable to update tables for new version</b><br />'.CR;

    }

  }

  // table upgrades; banlist
  if ($id == 'banlist') {

    // no upgrades so far

  }

  return;

}

function get_language_name($language_id) {

  include ('./lang/language_'.$language_id.'.php');
  return $LANG['lang'];

}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<!-- J.A.G. (Just Another Guestbook) v<?php echo $curversion; ?> - GNU Copyright (c) 2003 by crisp / freesoftware[at]xs4all.nl -->
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Pragma" content="no-cache">
<meta name="robots" content="noindex,nofollow">
<title><?php echo $guestbook_name.' - '.$LANG['setup']; ?></title>
<link rel="stylesheet" href="style/<?php echo $stylesheet; ?>" type="text/css">
<script type="text/javascript">

function languageSelect(el) {

  var newdef = 1;
  var radio = document.forms['setup'].elements['default_language'];
  var tot = radio.length;
  for (var i = 0; i < tot; i++) {
    if (radio[i].value == el.value) {
      radio[i].disabled = !el.checked;
      if (!el.checked) radio[i].checked = false;
    }
    if (radio[i].checked) newdef = 0;
  }

  if (newdef) {
    for (var i = 0; i < tot; i++) {
      if (!radio[i].disabled) {
        radio[i].checked = true;
        break;
      }
    }
  }

}

</script>
</head>
<body>
<?php

echo '<table>'.CR.
     '  <tr>'.CR.
     '    <td class="title"><a class="title" href="guestbook.php">'.$LANG['Back'].'</a></td>'.CR.
     '  </tr>'.CR.
     '</table><br />'.CR;

if ($error) {

  $guestbook_name = stripslashes($guestbook_name);
  $webmaster_email = stripslashes($webmaster_email);
  $site_homepage = stripslashes($site_homepage);
  $datetimeformat = stripslashes($datetimeformat);
  $notification_to = array_map('stripslashes', $notification_to);
  $id = stripslashes($id);
  $pw = stripslashes($pw);
  $host = stripslashes($host);
  $database = stripslashes($database);
  $table = stripslashes($table);
  $table_bl = stripslashes($table_bl);
  $adminpwds = array_map('stripslashes', $adminpwds);
  $lock_msg = stripslashes($lock_msg);
  echo $error.'<br />'.CR;

}

echo '<table>'.CR.
     '  <tr>'.CR.
     '    <td class="content"><div class="noalfa">'.CR.
     '      <form name="setup" action="setup.php" method="post">'.CR.
     '        <table class="noborder">'.CR.
     '          <tr>'.CR.
     '            <td width="240" valign="top"><br /><b>'.$LANG['gbsettings'].'</b><br /><br /></td>'.CR.
     '            <td></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['gbname'].':</td>'.CR.
     '            <td><input type="text" name="guestbook_name" value="'.htmlentities($guestbook_name).'" size="40" maxlength="50" style="width: 294px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['webmaster'].':</td>'.CR.
     '            <td><input type="text" name="webmaster_email" value="'.htmlentities($webmaster_email).'" size="40" maxlength="50" style="width: 294px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['site'].':</td>'.CR.
     '            <td><input type="text" name="site_homepage" value="'.htmlentities($site_homepage).'" size="40" maxlength="50" style="width: 294px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['style'].':</td>'.CR.
     '            <td><select name="stylesheet" style="width: 150px">'.CR;

$handle=opendir('./style/');
while ($file = readdir($handle)) {
  if (preg_match('/\.css$/', $file)) {
    echo '              <option value="'.$file.'"';
    if ($file == $stylesheet) echo ' selected="selected"';
    echo '>'.$file.'</option>'.CR;
  }
}

echo '            </select></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top"><br /><b>'.$LANG['gensettings'].'</b><br /><br /></td>'.CR.
     '            <td></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['msg_page'].':</td>'.CR.
     '            <td><input type="text" name="messages_per_page" value="'.$messages_per_page.'" size="4" maxlength="4" style="width: 42px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['navlength'].':</td>'.CR.
     '            <td><input type="text" name="navlength" value="'.$navlength.'" size="4" maxlength="4" style="width: 42px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['smilies'].':</td>'.CR.
     '            <td><input type="checkbox" name="use_smilies" value="1"';

if ($use_smilies) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['smllegend'].':</td>'.CR.
     '            <td><input type="checkbox" name="smilie_legend" value="1"';

if ($smilie_legend) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['smlkeys'].':</td>'.CR.
     '            <td><input type="checkbox" name="smilie_legend_keycodes" value="1"';

if ($smilie_legend_keycodes) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['legwidth'].':</td>'.CR.
     '            <td><input type="text" name="smilie_legend_width" value="'.$smilie_legend_width.'" size="6" maxlength="4" style="width: 56px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['ubb'].':</td>'.CR.
     '            <td><input type="checkbox" name="use_ubbcode" value="1"';

if ($use_ubbcode) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['ubblegend'].':</td>'.CR.
     '            <td><input type="checkbox" name="ubbcode_legend" value="1"';

if ($ubbcode_legend) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['legplace'].':</td>'.CR.
     '            <td><input type="radio" name="legend_placement" value="right"';

if ($legend_placement == 'right' || !$legend_placement) echo ' checked="checked"';

echo ' />&nbsp;'.$LANG['right'].'&nbsp;&nbsp;<input type="radio" name="legend_placement" value="bottom"';

if ($legend_placement == 'bottom') echo ' checked="checked"';

echo ' />&nbsp;'.$LANG['bottom'].'&nbsp;&nbsp;<input type="radio" name="legend_placement" value="popup"';

if ($legend_placement == 'popup') echo ' checked="checked"';

echo ' />&nbsp;'.$LANG['popup'].'</td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['legtitle'].':</td>'.CR.
     '            <td><input type="checkbox" name="legend_title" value="1"';

if ($legend_title) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['logip'].':</td>'.CR.
     '            <td><input type="checkbox" name="log_ipaddress" value="1"';

if ($log_ipaddress) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['parseurl'].':</td>'.CR.
     '            <td><input type="checkbox" name="parse_urls" value="1"';

if ($parse_urls) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['emailchk'].':</td>'.CR.
     '            <td><input type="checkbox" name="dft_showemail" value="1"';

if ($dft_showemail) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['dtformat'].':</td>'.CR.
     '            <td><input type="text" name="datetimeformat" value="'.$datetimeformat.'" size="20" maxlength="20" style="width: 144px; height:22px" />&nbsp;&nbsp;<a href="http://www.php.net/manual/en/function.date.php" target="_blank">'.$LANG['explan'].'</a></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['timeshift'].':</td>'.CR.
     '            <td><input type="text" name="timeshift" value="'.$timeshift.'" size="4" maxlength="4" style="width: 42px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['maxlength'].':</td>'.CR.
     '            <td><input type="text" name="max_content_length" value="'.$max_content_length.'" size="6" maxlength="6" style="width: 56px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['timelimit'].':</td>'.CR.
     '            <td><input type="text" name="time_limit" value="'.$time_limit.'" size="6" maxlength="6" style="width: 56px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['allowedit'].':</td>'.CR.
     '            <td><input type="checkbox" name="allow_edit" value="1"';

if ($allow_edit) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['notify'].':</td>'.CR.
     '            <td><input type="checkbox" name="email_notification" value="1"';

if ($email_notification) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['notify_to'].':</td>'.CR;

for ($i = 0; $i < 5; $i++) {
  if (!isset($notification_to[$i])) $notification_to[$i] = '';
  if ($i) echo '          <tr>'.CR.
               '            <td></td>'.CR;
  echo         '            <td><input type="text" name="notification_to[]" value="'.$notification_to[$i].'" size="40" maxlength="50" style="width: 294px; height:22px" /></td>'.CR.
               '          </tr>'.CR;
}

$handle=opendir('./lang/');
$i = 0;
$languages = array();
while ($file = readdir($handle)) {
  if (preg_match('/^language_[a-z]{2}\.php$/', $file)) {
    $language_id = substr($file, 9, 2);
    $languages[$i] = $language_id;
    echo '          <tr>'.CR;
    if (!$i) {
      echo '            <td valign="top">'.$LANG['avail_lang'].':</td>'.CR;
      $i = 0;
    } else {
      echo '            <td></td>'.CR;
    }
    echo '            <td><input type="checkbox" name="languages[]" value="'.$language_id.'"';
    if (isset($avail_languages[$language_id])) echo ' checked="checked"';
    echo ' onclick="languageSelect(this)">&nbsp;&nbsp;<img src="lang/flag_'.$language_id.'.gif" width="14" height="14" alt="" />&nbsp;&nbsp;'.get_language_name($language_id).' ('.$language_id.')</td>'.CR.
         '          </tr>'.CR;
    $i++;
  }
}

echo '          <tr>'.CR.
     '            <td valign="top">'.$LANG['dftlang'].':</td>'.CR.
     '            <td>';

for ($i = 0, $tot = count($languages); $i < $tot; $i++) {

  echo '<input type="radio" name="default_language" value="'.$languages[$i].'"';
  if ($languages[$i] == $default_language) echo ' checked="checked"';
  if (!isset($avail_languages[$languages[$i]])) echo ' disabled="disabled"';
  echo ' />&nbsp;'.$languages[$i].'&nbsp;&nbsp;';

}

echo '            </td>'.CR.
     '          </tr>'.CR;

echo '          <tr>'.CR.
     '            <td valign="top"><br /><b>'.$LANG['dbsettings'].'</b><br /><br /></td>'.CR.
     '            <td></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['id'].':</td>'.CR.
     '            <td><input type="text" name="id" value="'.htmlentities($id).'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['pw'].':</td>'.CR.
     '            <td><input type="text" name="pw" value="'.htmlentities($pw).'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['host'].':</td>'.CR.
     '            <td><input type="text" name="host" value="'.htmlentities($host).'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['database'].':</td>'.CR.
     '            <td><input type="text" name="database" value="'.htmlentities($database).'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['table'].':</td>'.CR.
     '            <td><input type="text" name="table" value="'.htmlentities($table).'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['table_bl'].':</td>'.CR.
     '            <td><input type="text" name="table_bl" value="'.htmlentities($table_bl).'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top"><br /><b>'.$LANG['secsettings'].'</b><br /><br /></td>'.CR.
     '            <td></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['admin'].':</td>'.CR;

$adminname = array_keys($adminpwd);
if ($error) $adminname = array_map('stripslashes', $adminname);
for ($i = 0; $i < 5; $i++) {
  if (!isset($adminname[$i])) $adminname[$i] = '';
  if (!isset($adminpwd[$adminname[$i]])) $adminpwd[$adminname[$i]] = '';
  if ($i) echo '          <tr>'.CR.
               '            <td></td>'.CR;
  echo         '            <td><input type="text" name="adminname[]" value="'.$adminname[$i].'" size="30" maxlength="20" style="width: 224px; height:22px" />&nbsp;<input type="text" name="adminpwds[]" value="'.$adminpwd[$adminname[$i]].'" size="30" maxlength="30" style="width: 224px; height:22px" /></td>'.CR.
               '          </tr>'.CR;
}

echo '          <tr>'.CR.
     '            <td valign="top">'.$LANG['readonly'].':</td>'.CR.
     '            <td><input type="checkbox" name="readonly" value="1"';

if ($readonly) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['lockdown'].':</td>'.CR.
     '            <td><input type="checkbox" name="lockdown" value="1"';

if ($lockdown) echo ' checked="checked"';

echo ' /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td valign="top">'.$LANG['lock_msg'].':</td>'.CR.
     '            <td><input type="text" name="lock_msg" value="'.htmlentities($lock_msg).'" size="80" maxlength="100" style="width: 504px; height:22px" /></td>'.CR.
     '          </tr>'.CR.
     '          <tr>'.CR.
     '            <td></td>'.CR.
     '            <td height="55"><input type="submit" value="'.$ACTION['save'].'" /></td>'.CR.
     '          </tr>'.CR.
     '        </table>'.CR.
     '        <input type="hidden" name="action" value="save" />'.CR.
     '      </form>'.CR.
     '    </div></td>'.CR.
     '  </tr>'.CR.
     '</table><br />'.CR;

$version = $curversion;
include ('./inc/copyright.php');

?>
</body>
</html>